#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <commctrl.h>

static long WaitTime = 100;
static CRITICAL_SECTION CS;
static DWORD WaitThreadHandle;


DWORD WINAPI WaitThread(LPVOID p)
/////////////////////////////////
{
  SetThreadPriority(GetCurrentThread(), THREAD_PRIORITY_TIME_CRITICAL);
  p=p;
  do
  {
      EnterCriticalSection (&CS);
      long Time = WaitTime;
      LeaveCriticalSection (&CS);

      long start = GetTickCount();
      while ((GetTickCount()-start) <= (201-Time));

      Sleep (Time);

    } while (1);
}


static BOOL CALLBACK DialogProc (HWND hwndDlg,UINT uMsg,WPARAM wParam,LPARAM lParam)
////////////////////////////////////////////////////////////////////////////////////
{
    wParam = wParam;
    lParam = lParam;

    switch (uMsg)
    {
        case WM_INITDIALOG:
        {
            SendDlgItemMessage (hwndDlg, 100, TBM_SETRANGE,      0,    MAKELONG (1, 200));
            SendDlgItemMessage (hwndDlg, 100, TBM_SETTICFREQ,    10,   1);
            SendDlgItemMessage (hwndDlg, 100, TBM_SETPOS,        TRUE, WaitTime);
            InitializeCriticalSection (&CS);
            CreateThread(0,8096,WaitThread,0,0,&WaitThreadHandle);
            return TRUE;
        };

        case WM_HSCROLL:
        {
            if (((HWND) lParam == GetDlgItem (hwndDlg, 100)) && (LOWORD (wParam) == SB_ENDSCROLL))
            {
                EnterCriticalSection (&CS);
                WaitTime = SendDlgItemMessage (hwndDlg, 100, TBM_GETPOS, 0,0);
                LeaveCriticalSection (&CS);
                return TRUE;
            }
        } break;

        case WM_COMMAND:
        {
            switch (LOWORD(wParam))
            {
                case IDCANCEL:
                case IDOK:
                {
                    DeleteCriticalSection (&CS);
                    EndDialog (hwndDlg, LOWORD(wParam));
                    return TRUE;
                }
            }
        } break;
    }
    return FALSE;
}



int PASCAL WinMain(HINSTANCE hInstance, HINSTANCE hPrevInst, LPSTR lpCmdLine, int nCmdShow)
///////////////////////////////////////////////////////////////////////////////////////////
{
    hInstance = hInstance;
    hPrevInst = hPrevInst;
    lpCmdLine = lpCmdLine;
    nCmdShow  = nCmdShow;
    DialogBox (hInstance, "DIALOG1", 0, (DLGPROC) DialogProc);
    return 0;
}



